//B.Vandeportaele 2022
//parti d'un programme d'exemple:
//https://riptutorial.com/qt/example/29874/tcp-server


#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QDebug>
#include <QHostAddress>
#include <QAbstractSocket>

#include <QtWidgets>
#include <QtNetwork>


#include<iostream>
/*
 * ../tcp_server/mainwindow.cpp:33:31: warning: range-based 'for' loops only available with -std=c++11 or -std=gnu++11
 for (QTcpSocket* socket : _sockets) {
If you are using Qt5, add CONFIG += c++11 to your .pro file, that works on all systems.

*/



void Receiver::onNewConnection()
{
    QTcpSocket *clientSocket = _server.nextPendingConnection();
    connect(clientSocket, SIGNAL(readyRead()), this, SLOT(onReadyRead()));
    connect(clientSocket, SIGNAL(stateChanged(QAbstractSocket::SocketState)), this, SLOT(onSocketStateChanged(QAbstractSocket::SocketState)));

    _sockets.push_back(clientSocket);
    for (QTcpSocket* socket : _sockets) {

        //std::cout<< QByteArray::fromStdString(clientSocket->peerAddress().toString().toStdString() .c_str());
        std::cout<< clientSocket->peerAddress().toString().toStdString()<< endl;

        std::cout<<      " connected to server !"<< endl;
        //        socket->write(QByteArray::fromStdString(clientSocket->peerAddress().toString().toStdString() + " connected to server !\n"));
        //socket->write(QByteArray::fromStdString("salut"));

    }
}

//TODO, il faudra gérer la libération de la connexion

void Receiver::onSocketStateChanged(QAbstractSocket::SocketState socketState)
{
    if (socketState == QAbstractSocket::UnconnectedState)
    {
        QTcpSocket* sender = static_cast<QTcpSocket*>(QObject::sender());
        _sockets.removeOne(sender);
    }
}

void Receiver::onReadyRead()
{
    //traitement des requetes recues
    QTcpSocket* sender = static_cast<QTcpSocket*>(QObject::sender());
    QByteArray datas = sender->readAll();
    std::cout<<" recu:" << datas.toStdString().c_str() << endl;
    //renvoie une réponse à l'émeteur de la requete
    for (QTcpSocket* socket : _sockets) {
        if (socket == sender){
            unsigned int nbr;
            std::string st=datas.toStdString();
            //std::string reponse;
            char chaine[100];
            switch (st[0]){
            case 'g':
                nbr=getInputs();
                break;
            case 's':
                sscanf(datas.toStdString().c_str(),"s %d\n",&nbr);
                setOuputs(nbr);
                break;
            case 'n':
                nameLabel->setText(QString("Nom:")+QString(datas.toStdString().c_str()+2).replace("\n"," ")); //retire les retours à la ligne pour éviter que le widget soit trop haut
                break;
            case 'm':
                msgLabel->setText(QString("Msg:")+QString(datas.toStdString().c_str()+2).replace("\n"," "));  //retire les retours à la ligne pour éviter que le widget soit trop haut
                break;
            }
            sprintf(chaine, "%03d\n",nbr);
            socket->write(chaine);
        }
    }
}


unsigned char Receiver::getInputs(){
    unsigned char val=0;
    for (int i=0;i<8;i++){
        if (sw_inputs[i]->checkState()==Qt::Checked)
            val|=(1<<i);
    }
    QString hexvalue = QString("0x%1").arg(val, 2, 16, QLatin1Char( '0' )); // 2 digits en base 16 complété avec des 0
    inputLabel->setText(hexvalue);
    return val;
}

void Receiver::setOuputs(unsigned char val ){

    for (int i=0;i<8;i++){
        //sw_outputs[i]->setCheckable(true);
        sw_outputs[i]->setChecked(((val>>i)&1)!=0);
        //        sw_outputs[i]->setCheckable(false);
    }
    /*
 *       //sw_outputs[i]->repaint();
        //sw_outputs[i]->update();
    sw_outputs[2]->setChecked(true);
    sw_outputs[3]->setChecked(false);
    sw_outputs[4]->setCheckState(Qt::Checked);
    sw_outputs[5]->setCheckState(Qt::PartiallyChecked);
    /*for (int i=0;i<8;i++){
        if (((val>>i)&1)!=0)
            sw_outputs[i]->setCheckState(Qt::PartiallyChecked);
            //sw_outputs[i]->setCheckState(Qt::Checked);
        else
            sw_outputs[i]->setCheckState(Qt::Unchecked);
    }*/

    QString hexvalue = QString("0x%1").arg(val, 2, 16, QLatin1Char( '0' )); // 2 digits en base 16 complété avec des 0
    outputLabel->setText(hexvalue);
    //outputLabel->update();
    //this->update();
    //    this->repaint();
    //this->parentWidget()->repaint();
    //this->parentWidget()->parentWidget()->repaint();

}


Receiver::Receiver(QWidget *parent)
    : QDialog(parent)
{
    //statusLabel = new QLabel(tr("En attente de datagrammes UDP depuis le PIC32"));

    inputLabel = new QLabel(tr("0x--"));
    outputLabel = new QLabel(tr("0x--"));
    nameLabel = new QLabel(tr("Nom:"));
    msgLabel = new QLabel(tr("Msg:"));

    quitButton = new QPushButton(tr("&Quit"));


    connect(quitButton, SIGNAL(clicked()), this, SLOT(close()));

    QHBoxLayout *buttonLayout = new QHBoxLayout;
    buttonLayout->addStretch(1);
    buttonLayout->addWidget(quitButton);
    buttonLayout->addStretch(1);

    QHBoxLayout *button1Layout = new QHBoxLayout;
    button1Layout->addStretch(1);
    QHBoxLayout *button2Layout = new QHBoxLayout;
    button2Layout->addStretch(1);
    for (int i=7;i>=0;i--){
        sw_inputs[i] = new QCheckBox("in"+ QString::number(i), this);
        button1Layout->addWidget(sw_inputs[i]);
        button1Layout->addStretch(1);
        sw_outputs[i] = new QCheckBox("ou"+ QString::number(i), this);
        //sw_outputs[i]->setCheckable(false);
        //sw_outputs[i]->setCheckState(Qt::PartiallyChecked); //avant de recevoir une commande, la sortie est non initialisée
        button2Layout->addWidget(sw_outputs[i]);
        button2Layout->addStretch(1);
    }
    button1Layout->addWidget(inputLabel);
    button1Layout->addStretch(1);
    button2Layout->addWidget(outputLabel);
    button2Layout->addStretch(1);

    QVBoxLayout *mainLayout = new QVBoxLayout;
    mainLayout->addLayout(buttonLayout);
    mainLayout->addLayout(button1Layout);
    mainLayout->addLayout(button2Layout);
    //mainLayout->addWidget(statusLabel);
    mainLayout->addWidget(nameLabel);
    mainLayout->addWidget(msgLabel);

    setLayout(mainLayout);

    setWindowTitle(tr("appli serveur TCP CESI B.Vandeportaele 2022"));
    _server.listen(QHostAddress::Any, 4242);
    connect(&_server, SIGNAL(newConnection()), this, SLOT(onNewConnection()));
    this->setGeometry(10,10,600,100);
}
