//B.Vandeportaele 2022

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTcpServer>
#include <QTcpSocket>
#include <QDialog>
#include <QCheckBox>
#include <QSlider>


QT_BEGIN_NAMESPACE
class QLabel;
class QPushButton;
class QUdpSocket;
QT_END_NAMESPACE

class Receiver : public QDialog
{
    Q_OBJECT
public:
    Receiver(QWidget *parent = 0);
private:
    QLabel *statusLabel;
    QPushButton *quitButton;
    QCheckBox * sw_inputs[8];
    QCheckBox * sw_outputs[8];
    QTcpServer  _server;
    QList<QTcpSocket*>  _sockets;

    unsigned char getInputs();
    void setOuputs(unsigned char val);

    QLabel *inputLabel;
    QLabel *outputLabel;
    QLabel *nameLabel;
    QLabel *msgLabel;

public slots:
    void onNewConnection();
    void onSocketStateChanged(QAbstractSocket::SocketState socketState);
    void onReadyRead();
};





#endif // MAINWINDOW_H
